
#include "uart.h"

//****************************************
//            UART
//****************************************

//#ifdef UART_BAUD_RATE

unsigned char uart_recv_buf[41]	= {'\0'};
volatile unsigned char uart_recv_counter	= 0;
volatile unsigned char uart_cr 				= 0;
volatile unsigned char uart_lf 				= 0;
volatile unsigned long uart_baut			= 19200;
		 unsigned long baut_select 			= 0;


//	UART initialisieren
void uart_init(void){

	baut_select = (16000000/(uart_baut*16l)-1);

    UCSRB = ((1<<RXCIE)|(1<<RXEN)|(1<<TXEN));		//	Interrupts enable fr RxD/TxD
	UBRRL = ((unsigned char)(baut_select));			//	Baudrate festlegen (LOW-Byte)
	UBRRH = 0;										//	Baudrate festlegen (HIGH-Byte)
}




// ---------- EMPFANGEN ----------

// Zeichen empfangen
ISR(USART_RXC_vect){						//	Interrupt fr UART Byte empfangen     

	uart_recv_buf[uart_recv_counter] = UDR;
 
	if (uart_recv_buf[uart_recv_counter] == UART_CR){	//bei Eingang von Return

		uart_recv_buf[uart_recv_counter] = 0;
		uart_cr = 1;	
		uart_recv_counter = 0;
	}
	
	else if (uart_recv_buf[uart_recv_counter] == UART_LF){	//bei Eingang von LF

		uart_recv_buf[uart_recv_counter] = 0;
		uart_lf = 1;	
		uart_recv_counter = 0;
	}

	else uart_recv_counter++;
}


// Besttigung des Empfangs und lschen des Empfangsbuffers
void uart_done(void){

	for(int i = 0; i<30; i++) uart_recv_buf[i]='\0';
	uart_cr = 0;
	uart_lf = 0;
}


// Zahl empfangen
int uart_getnumber(int pos){

	char num_buf[5];

	for(int i = 0; i<= 5; i++) num_buf[i] = uart_recv_buf[pos + i];
	
	return atoi(num_buf);
}



//#endif






